leetcode题目 寻找和为SUM的两数(O(nlogn)和O(n)解法)

leetcode第一题
题目: Given an array of integers, find two numbers such that they add up to a specific target number.

The function twoSum should return indices of the two numbers such that they add up to the target, where index1 must be less than index2. Please note that your returned answers (both index1 and index2) are not zero-based.

You may assume that each input would have exactly one solution.

Input: numbers={2, 7, 11, 15}, target=9
Output: index1=1, index2=2
思路: 解法有三种,暴力法,排序寻找,哈希表。时间复杂度分别为O(n2),O(nlogn),O(n)。本文实现了后两种。

解法1: 先排序,再寻找。

class Solution {
public:
    vector<int> twoSum(vector<int>& nums, int target) {
        vector<int> result;
        vector<int> copy;
        copy=nums;
        sort(copy.begin(),copy.end());
        auto fir=copy.begin();
        auto sec=--copy.end();
        while(fir<sec&&*fir+*sec!=target)
        {
            if(*fir+*sec>target)
                sec--;
            else
                fir++;
        }
        auto pos1=nums.begin();
        auto pos2=nums.begin();
        if(*fir!=*sec)
        {
            pos1=find(nums.begin(),nums.end(),*fir);
            pos2=find(nums.begin(),nums.end(),*sec);  
            if(pos1>pos2)
            {
                auto temp=pos1;
                pos1=pos2;
                pos2=temp;
            }
        }
        else
        {
            pos1=find(nums.begin(),nums.end(),*fir);
            pos2 = find(pos1+1, nums.end(), *sec);
        }
        result.push_back(pos1-nums.begin()+1);
        result.push_back(pos2-nums.begin()+1);
        return result;
    }
};

运行时间12ms,击败了89%的代码
这里写图片描述

解法二: 利用哈希表,复杂度O(n)

 class Solution {
public:
    vector<int> twoSum(vector<int>& nums, int target) {
        vector<int> result;
        auto pos1 = nums.begin();
        auto pos2 = pos1;
        unordered_map<int, vector<int>::iterator> iht;
        auto pos = iht.begin();
        for (auto i = nums.begin(); i != nums.end(); ++i)
        {
            pos = iht.find(target - *i);
            if (pos == iht.end())
            {
                iht.insert(pair<int, vector<int>::iterator>(*i, i));   
            }
            else
            {
                pos2 = i;
                break;
            }
        }
        pos1 = iht[target-*pos2];
        result.push_back(pos1 - nums.begin() + 1);
        result.push_back(pos2 - nums.begin() + 1);
        return result;
    }
};

运行时间16ms,击败了58%的代码,讨论区采用类似算法的效果也不太好,好奇怪。
这里写图片描述

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值